var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import { reorderColumns } from '../../actionCreators';
import defaultOptions from '../../defaultOptions';
import { headCellDispatchWrapper } from '../../Utils/CellResizeUtils';
import { addElementAttributes, getElementCustomization } from '../../Utils/ComponentUtils';
import { getDraggableProps } from '../../Utils/PropsUtils';
import { isSortingEnabled } from '../../Utils/SortUtils';
import HeadCellContent from '../HeadCellContent/HeadCellContent';
import HeadCellResize from '../HeadCellResize/HeadCellResize';
var HeadCell = function (props) {
    var columnReordering = props.columnReordering, _a = props.column, style = _a.style, isResizable = _a.isResizable, key = _a.key, dispatch = props.dispatch, sortingMode = props.sortingMode;
    var headCell = props.childComponents.headCell;
    var _b = React.useState(style ? style.width : undefined), width = _b[0], setWidth = _b[1];
    var stateStyle = __assign(__assign({}, style), { width: width });
    var headCellDispatch = headCellDispatchWrapper(setWidth, dispatch);
    if (columnReordering) {
        var reorderedRowProps = getDraggableProps(key, dispatch, reorderColumns, defaultOptions.css.draggedColumn, defaultOptions.css.dragOverColumn);
        headCell = addElementAttributes(reorderedRowProps, props, headCell);
    }
    var _c = getElementCustomization({
        className: defaultOptions.css.theadCell + " " + defaultOptions.css.theadBackground + " " + (isSortingEnabled(sortingMode) ? 'ka-pointer' : ''),
        style: stateStyle,
        scope: 'col'
    }, props, headCell), elementAttributes = _c.elementAttributes, content = _c.content;
    return (React.createElement("th", __assign({}, elementAttributes),
        React.createElement("div", { className: defaultOptions.css.theadCellWrapper },
            React.createElement("div", { className: defaultOptions.css.theadCellContentWrapper }, content || React.createElement(HeadCellContent, __assign({}, props))),
            isResizable && (React.createElement(HeadCellResize, __assign({}, props, { currentWidth: width, dispatch: headCellDispatch }))))));
};
export default HeadCell;