var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import { updateSortDirection } from '../../actionCreators';
import defaultOptions from '../../defaultOptions';
import { SortDirection } from '../../enums';
import { getElementCustomization } from '../../Utils/ComponentUtils';
import { isSortingEnabled } from '../../Utils/SortUtils';
var HeadCellContent = function (props) {
    var column = props.column, dispatch = props.dispatch, sortingMode = props.sortingMode, headCellContent = props.childComponents.headCellContent;
    var sortingEnabled = isSortingEnabled(sortingMode);
    var onClick = sortingEnabled ? function () {
        dispatch(updateSortDirection(column.key));
    } : undefined;
    var _a = getElementCustomization({
        className: defaultOptions.css.theadCellContent + " " + (sortingEnabled ? 'ka-pointer' : ''),
        onClick: onClick
    }, props, headCellContent), elementAttributes = _a.elementAttributes, content = _a.content;
    return (React.createElement("div", __assign({}, elementAttributes),
        content || React.createElement("span", null, column.title),
        column.sortDirection && sortingEnabled && (React.createElement("span", { className: column.sortDirection === SortDirection.Ascend
                ? defaultOptions.css.iconSortArrowUp
                : defaultOptions.css.iconSortArrowDown }))));
};
export default HeadCellContent;