var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import defaultOptions from '../../defaultOptions';
import { ActionType, EditingMode, FilteringMode, SortingMode } from '../../enums';
import { getElementCustomization } from '../../Utils/ComponentUtils';
import { getExpandedGroups } from '../../Utils/GroupUtils';
import { prepareTableOptions } from '../../Utils/PropsUtils';
import TableBody from '../TableBody/TableBody';
import { TableHead } from '../TableHead/TableHead';
export var TableWrapper = function (props) {
    var _a = props.childComponents, childComponents = _a === void 0 ? {} : _a, columnReordering = props.columnReordering, _b = props.data, data = _b === void 0 ? [] : _b, dispatch = props.dispatch, _c = props.editableCells, editableCells = _c === void 0 ? [] : _c, _d = props.editingMode, editingMode = _d === void 0 ? EditingMode.None : _d, _e = props.filteringMode, filteringMode = _e === void 0 ? FilteringMode.None : _e, groups = props.groups, _f = props.rowReordering, rowReordering = _f === void 0 ? false : _f, _g = props.selectedRows, selectedRows = _g === void 0 ? [] : _g, _h = props.sortingMode, sortingMode = _h === void 0 ? SortingMode.None : _h, virtualScrolling = props.virtualScrolling;
    var groupsExpanded = props.groupsExpanded;
    var preparedOptions = prepareTableOptions(props);
    if (groups && !groupsExpanded) {
        groupsExpanded = getExpandedGroups(preparedOptions.groupedData);
    }
    var areAllRowsSelected = data.length === selectedRows.length;
    var tableWrapper = getElementCustomization({
        className: defaultOptions.css.tableWrapper,
        onScroll: virtualScrolling ? function (event) {
            dispatch({
                scrollTop: event.currentTarget.scrollTop,
                type: ActionType.ScrollTable,
            });
        } : undefined,
    }, __assign(__assign({}, props), { dispatch: dispatch }), childComponents.tableWrapper);
    var _j = getElementCustomization({
        className: defaultOptions.css.table,
    }, __assign(__assign({}, props), { dispatch: dispatch }), childComponents.table), elementAttributes = _j.elementAttributes, content = _j.content;
    return (React.createElement("div", __assign({}, tableWrapper.elementAttributes), content || tableWrapper.content || (React.createElement("table", __assign({}, elementAttributes),
        React.createElement(TableHead, { areAllRowsSelected: areAllRowsSelected, childComponents: childComponents, columnReordering: columnReordering, columns: preparedOptions.columns, dispatch: dispatch, filteringMode: filteringMode, groupColumnsCount: preparedOptions.groupColumnsCount, sortingMode: sortingMode }),
        React.createElement(TableBody, __assign({}, props, { childComponents: childComponents, columns: preparedOptions.columns, data: preparedOptions.groupedData, dispatch: dispatch, editableCells: editableCells, editingMode: editingMode, groupColumnsCount: preparedOptions.groupColumnsCount, groupedColumns: preparedOptions.groupedColumns, groupsExpanded: groupsExpanded, rowReordering: rowReordering, selectedRows: selectedRows }))))));
};